Polymer({
	is:"dd-file-browser",
	properties:{
		loginName:{ observer:"callRootUsernameFolder"},
		mobile:{observer:"screenSizeChanged"}
	},
	//------------------------------------------------
	ready:function(){
		this.displayItems = [];
		this.folder = "/";
		this.showBackButton = false;
		this.hideContextMenu = true;
		this.hideNewFolder = true;
		this.selectedItem = {};
		this.newName = "";
		this.uploadProgress = 0;
		this.draggedItem = {};
		this.selectedMedia = "";
		this.hideStreamMediaButton = true;
	},
	//------------------------------------------------
	openVideo:function(){
		this.$.streamDialog.opened = true;
	},
	//------------------------------------------------
	showPasswordDialog:function(){
		this.$.passwordDialog.opened = true;
	},
	//------------------------------------------------
	submitPassword:function(){
		this.$.ajaxChangeUserPassword.body = JSON.stringify({'PASSWORD':this.newPassword});
		this.$.ajaxChangeUserPassword.generateRequest();
		this.toastText = "Submitting New Password";
		this.openToast = true;
	},
	//------------------------------------------------
	callRootUsernameFolder:function(){
		this.$.ajaxGetFilesInFolder.params = {'FOLDER':'/',
											  'USERNAME':this.loginName};
		this.$.ajaxGetFilesInFolder.generateRequest();
	},
	//------------------------------------------------
	fileForwardTraverse:function(e){
		this.selectedItem = e.model.__data__.file;
		if(Polymer.dom(e).localTarget.id == "folderClick"){
			this.showBackButton = true;
			var file = e.model.__data__.file;
			if(file.EXT == false && file.TYPE == 'dir') {
				this.folder += file.FILENAME+"/";
				this.$.ajaxGetFilesInFolder.params = {'FOLDER':this.folder,
													  'USERNAME':this.loginName};
				this.$.ajaxGetFilesInFolder.generateRequest();
			}
		}
		else if(Polymer.dom(e).localTarget.id == this.selectedItem.ID){
			this.renameItem();
		}
	},
	//------------------------------------------------
	fileBackwardTraverse:function(e){
		this.folder = this.folder.substring(0, this.folder.length - 1);
		this.folder = this.folder.replace(/\/[^\/]+$/, '');
		this.folder += '/';
		
		this.$.ajaxGetFilesInFolder.params = {'FOLDER':this.folder,
											  'USERNAME':this.loginName};
		this.$.ajaxGetFilesInFolder.generateRequest();
	},
	//------------------------------------------------
	deleteItem:function(e){
		var file = e.model.__data__.file;
		this.$.ajaxDeleteFolder.body = JSON.stringify({'FILENAME':file.FILENAME,
													   'FILEPATH':this.folder});
		this.$.ajaxDeleteFolder.generateRequest();
	},
	//------------------------------------------------
	createFolder:function(){
		this.newFolder = "New Folder";
		this.hideNewFolder = false;
	},
	//------------------------------------------------
	detectEnterPress:function(e){
		if(e.keyIdentifier == "Enter"){
			this.toastText = "Creating Folder, please wait...";
			this.openToast = true;
			this.hideNewFolder = true;
			this.$.ajaxAddNewFolder.body = JSON.stringify({"FOLDER":this.newFolder,
														   "PATH":this.folder});
			this.$.ajaxAddNewFolder.generateRequest();
		}
	},
	//------------------------------------------------
	clickOutsideInput:function(){
		if(this.hideNewFolder == false){
			this.toastText = "Creating Folder, please wait...";
			this.openToast = true;
			this.hideNewFolder = true;
			this.$.ajaxAddNewFolder.body = JSON.stringify({"FOLDER":this.newFolder,
														   "PATH":this.folder});
			this.$.ajaxAddNewFolder.generateRequest();
		}
	},
	//------------------------------------------------
	clickOutsideRenameInput:function(){
		document.getElementById(this.selectedItem.ID).hidden = false;
		document.getElementById(this.selectedItem.INPUTID).hidden = true;
		this.toastText = "Renaming Folder, please wait...";
		this.openToast = true;
		this.$.ajaxRenameItem.body = JSON.stringify({"OLDNAME":this.selectedItem.FILENAME,
													 "NEWNAME":this.newName,
													 "PATH":this.folder});
		this.$.ajaxRenameItem.generateRequest();
	},
	//------------------------------------------------
	detectRenameEnterPress:function(e){
		if(e.keyIdentifier == "Enter"){
			document.getElementById(this.selectedItem.ID).hidden = false;
			document.getElementById(this.selectedItem.INPUTID).hidden = true;
			this.toastText = "Renaming Folder, please wait...";
			this.openToast = true;
			this.$.ajaxRenameItem.body = JSON.stringify({"OLDNAME":this.selectedItem.FILENAME,
														 "NEWNAME":this.newName,
														 "PATH":this.folder});
			this.$.ajaxRenameItem.generateRequest();
		}
	},
	//------------------------------------------------
	rightClickMenu:function(e){
		this.selectedItem = e.model.__data__.file;
		this.selectedMedia = e.model.__data__.file;
		this.hideContextMenu = false;
		if(this.isStreamAble(e.model.__data__.file.EXT) === true) {
			this.hidePlayButton = false;
		}
		else {
			this.hidePlayButton = true;
		}
		var posX = e.clientX;
		var posY = e.clientY;
		this.boxPosition = "position:absolute; left:"+posX+"px; top:"+posY+"px;";
		return false;
	},
	//------------------------------------------------
	closeContextMenu:function(e){
		if(Polymer.dom(e).localTarget.id != "contextMenu"){
			this.boxPosition = "position:absolute; left:4000px; top:4000px;";
			this.hideContextMenu = true;
		}
	},
	//------------------------------------------------
	renameFolder:function(){
		this.$.ajaxRenameItem.body = JSON.stringify({'OLDNAME':this.selectedItem.FILENAME,
													 'NEWNAME':this.newName,
													 'PATH':this.folder});
		this.$.ajaxRenameItem.generateRequest();
	},
	//------------------------------------------------
	renameItem:function(){
		this.newName = this.selectedItem.FILENAME;
		var id = document.getElementById(this.selectedItem.ID).hidden = true;
		var id = document.getElementById(this.selectedItem.INPUTID).hidden = false;
	},
	//------------------------------------------------
	downloadItem:function(e){ 
		var fileName = encodeURIComponent(this.selectedItem.FILENAME);
		var path = encodeURIComponent(this.folder);
		//window.open(window.location.origin+"/dropFilesBackend/index.php/main/DownloadItem?FILENAME="+fileName+"&PATH="+path,"_blank");
		window.location.href = window.location.origin+"/dropFilesBackend/index.php/main/DownloadItem?FILENAME="+fileName+"&PATH="+path;
		
		//this.$.ajaxDownloadItem.params = {"FILENAME":this.selectedItem.FILENAME,
		//								  "PATH":this.folder};
		//this.$.ajaxDownloadItem.generateRequest();
		this.toastText = "Downloading "+this.selectedItem.FILENAME;
		this.openToast = true;
	},
	//------------------------------------------------
	streamItem:function(){
		// this.selectedMedia.EXT
		this.$.streamDialog.opened = true;
		var folderPath = this.folder+""+this.selectedMedia.FILENAME;
		this.hideStreamMediaButton = false;
		this.streamPath = window.location.protocol+"//"+window.location.host+"/"+"dropFilesBackend/index.php/main/StreamItem?FOLDERPATH="+folderPath+"&EXT="+this.selectedMedia.EXT;
	},
	//------------------------------------------------
	contextDelete:function(){
		this.$.ajaxDeleteFolder.body = JSON.stringify({'FILENAME':this.selectedItem.FILENAME,
													   'FILEPATH':this.folder});
		this.$.ajaxDeleteFolder.generateRequest();
		this.hideContextMenu = true;
	},
	//------------------------------------------------
	logoutUser:function(){
		this.$.ajaxLogoutUser.generateRequest();
	},
	//------------------------------------------------
	browseFiles: function() {
	    var elem = this.$.fileInput;
	    if (elem && document.createEvent) {
	        var evt = document.createEvent("MouseEvents");
	        evt.initEvent("click", true, false);
	        elem.dispatchEvent(evt);
	    }
    },
	//------------------------------------------------
	uploadFile:function(e){
		this.files = e.target.files;
        if (this.files.length < 1) {
          	return;
        }

        var formData = new FormData();
        for(var i = 0; i < this.files.length; i++) {
        	var file = this.files[i];
        	formData.append(i, file, file.name);
        }
        formData.append('FOLDER',this.folder);
        var xhr = new XMLHttpRequest();

        xhr.upload.onprogress = function(e) {
	        var done = e.loaded, total = e.total;  
	        var currentProgress = Math.floor((done/total)*1000)/10;
	        document.getElementById('progressBar').value = currentProgress;
	        document.getElementById('percentProgress').innerHTML = currentProgress+" %";
	        if(done >= total) {
	        	document.getElementById('uploadText').innerHTML = "Upload Complete, refreshing file list";
	        	setTimeout(closeToast, 3000);
	        	function closeToast(){
	        		document.getElementById('permToast').opened = false;
	        	}
	        }
        };

        var url = "../../../dropFilesBackend/index.php/main/UploadFile";
        xhr.open('POST', url, true);

        xhr.onload = function(e) {
          	if (xhr.status === 200) {
	            document.getElementById('ajaxGetFilesInFolder').generateRequest();
          	} 
          	else {
          		document.getElementById('permToast').opened = false;
          	}
        };

        xhr.send(formData);
        document.getElementById('permToast').opened = true;
        document.getElementById('uploadText').innerHTML = "Uploading File(s)";
	},
////////////////////////// AJAX RESPONSES //////////////////////
	ajaxStreamItemResponse:function(){
		console.log(this.stream);
	},
	ajaxChangeUserPasswordResponse:function(){
		this.toastText = "Password Change Responded with: "+this.passwordStatus;
		this.openToast = true;
	},
	ajaxLogoutUserResponse:function(){
		document.getElementById('pageSelector').selected = 0;
	},
	ajaxDownloadItemResponse:function(){
		this.toastText = "Download Complete";
		this.openToast = true;
	},
	ajaxAddNewFolderResponse:function(){
		this.toastText = "Folder creation Response: \""+this.folderCreated+"\"";
		this.openToast = true;
		this.hideNewFolder = true;
		this.$.ajaxGetFilesInFolder.params = {'FOLDER':this.folder,
											  'USERNAME':this.loginName};
		this.$.ajaxGetFilesInFolder.generateRequest();
	},
	ajaxDeleteFolderResponse:function(){
		this.$.ajaxGetFilesInFolder.params = {'FOLDER':this.folder,
											  'USERNAME':this.loginName};
		this.$.ajaxGetFilesInFolder.generateRequest();
	},
	ajaxMoveFileResponse:function(){
		
	},
	ajaxRenameItemResponse:function(){
		this.toastText = "Rename Response: "+this.fileRenamed;
		this.openToast = true;
		this.$.ajaxGetFilesInFolder.params = {'FOLDER':this.folder,
											  'USERNAME':this.loginName};
		this.$.ajaxGetFilesInFolder.generateRequest();
	},
	ajaxGetFilesInFolderResponse:function(){
		var holder = {};
		this.displayItems = [];
		for(var i in this.files) {
			this.files[i] = this.setImageExtension(this.files[i]);
			this.push("displayItems",this.files[i]);
			
		}
		this.$.allItemsInFolder.render();
	},
	//------------------------------------------
	isStreamAble:function(extension){
		var returnValue = false;
		switch(extension){
			case "mp3":
			case "wav":
			case "m4p":
			case "wma":
			case "mkv":
			case "avi":
			case "mov":
			case "wmv":
			case "mp4":
			case "m4v":
			case "mpeg":
			case "mpg":
			case "m4v":
				returnValue = true;
				break;
			default:
				returnValue = false;
				break;
		}
		return returnValue;
	},
	//------------------------------------------
	setImageExtension:function(file) {
		var image = "";
		var showExt = true;
		switch(file.EXT){
			case "txt":
				image = "images/items/text.png";
				break;
			case "pdf":
				image = "images/items/pdf.png";
				break;
			case "doc":
			case "docx":
				image = "images/items/word.png";
				break;
			case "mp3":
			case "wav":
			case "m4p":
			case "wma":
				image = "images/items/music.png";
				break;
			case "xlsx":
			case "xls":
			case "xlt":
			case "xlm":
				image = "images/items/excel.png";
				break;
			case "css":
				image = "images/items/css.png";
				break;
			case "zip":
				image = "images/items/compressed.png";
				break;
			case "config":
				image = "images/items/config.png";
				break;
			case "html":
				image = "images/items/html.png";
				break;
			case "jpeg":
			case "jpg":
			case "gif":
			case "bmp":
			case "png":
				image = "images/items/image.png";
				break;
			case "mkv":
			case "avi":
			case "mov":
			case "wmv":
			case "mp4":
			case "m4v":
			case "mpeg":
			case "mpg":
			case "m4v":
				image = "images/items/movie.png";
				break;
			case "ppt":
			case "pptx":
			case "pptm":
				image = "images/items/powerpoint.png";
				break;
			case "exe":
				image = "images/items/exe.png";
				break;
			case "iso":
				image = "images/items/iso.png";
				break;
			case "dll":
				image = "images/items/dll.png";
				break;
			case "php":
				image = "images/items/php.png";
				break;
			case "unitypackage":
				image = "images/items/unity.png";
				break;
			case false:
				if(file.TYPE === 'dir'){
					image = "images/items/folder.png";
				}
				else {
					image = "images/items/default.png";
				}
				showExt = false;
				break;
			default:
				this.set("file.EXT","");
				image = "images/items/default.png";
				break;
		}
		var returnFile = {'FILENAME':file.FILENAME,
						  'EXT':file.EXT,
						  'DATE':file.DATE,
						  'SHOWEXT':showExt,
						  'IMAGE':image,
						  'ID':file.ID,
						  'INPUTID':file.INPUTID,
						  'TYPE':file.TYPE};
		return returnFile;
	},
	//-------------------------------------------
	screenSizeChanged:function(){
		if(this.mobile === true) {
			this.headerBar = "header-bar-mobile";
			this.mobileBarHidden = false;
			this.folderPath = "folder-path-mobile";
			this.previousButton = "previous-button-mobile";
			this.reopenButton = "reopen-button-mobile";
			this.fileViewBox = "file-view-box-mobile";
			this.fileExplainBox = "file-explain-box-mobile";
			this.explainFilename = "explain-filename-mobile";
			this.explainFiletype = "explain-filetype-mobile";
			this.explainDate = "explain-date-mobile";
		}
		else {
			this.headerBar = "header-bar";
			this.mobileBarHidden = true;
			this.folderPath = "folder-path";
			this.previousButton = "previous-button";
			this.reopenButton = "reopen-button";
			this.fileViewBox = "file-view-box";
			this.fileExplainBox = "file-explain-box";
			this.explainFilename = "explain-filename";
			this.explainFiletype = "explain-filetype";
			this.explainDate = "explain-date";
		}
	}
	//-------------------------------------------
});	