<?php
	if(defined('onyxCore.php')) {
		return;
	}
	define('onyxCore.php', '');
	//------------------------------------------------------------------------------
	define('cNoDefault', '~~NoDefault~~');
	define('cStrInvalidSqlChars', "'");
	define('DS', DIRECTORY_SEPARATOR);
	//------------------------------------------------------------------------------
	define('cException', 'Exception');
	define('cENullValueInvalid', 'ENullValueInvalid');
	define('cEKeyNotFound', 'EKeyNotFound');
	define('cEParseErr', 'EParseErr');
	define('cEEmptyStrInvalid', 'EEmptyStrInvalid');
	define('cEErrFailedToThrow', 'EErrFailedToThrow');
	//-----------------------------------------------------------------------------
	function connectToDB(){
		include getcwd()."/protected/config/main.php";
	}
	//-----------------------------------------------------------------------------
	function queryDB($sql) {
		//Create connection
		$connection = require_once(getcwd()."/protected/config/connection.php");
		
		//$conn = new mysqli($connection['SERVERNAME'], $connection['USERNAME'], 
		//					$connection['PASSWORD'], $connection['DBNAME']);
		$conn = new mysqli('localhost', 'generic', 'something7connecting', 'files_db');
							
		// Check connection
		if ($conn->connect_error) {
			die("Connection failed: " . $conn->connect_error);
		} 

		$result = $conn->query($sql);
		if(!is_bool($result)){
			$result = $result->fetch_assoc();
		}
		return $result;
		$conn->close();
	}
	//-----------------------------------------------------------------------------
	function strToBool($bool) {
		verify(is_string($bool) || is_bool($bool), 'param must be a string');
		if(is_bool($bool)) {
			return $bool;
		}
		$firstLetter = $bool[0];
		if(stristr('TY1', $firstLetter) !== false) {
			return true;
		}
		if(stristr('FN0', $firstLetter) !== false) {
			return false;
		}
		if(stristr('1', $firstLetter) !== false) {
			return true;
		}
		if(stristr('0', $firstLetter) !== false) {
			return false;
		}
		err("Unable to convert $bool to boolean");
	}
	//-----------------------------------------------------------------------------
	function fileLogDebug($value, $fileName = 'log.txt') {
		$debugStr = toDebugStr($value);
		fileLog($debugStr, $fileName, 2);
	}
	//------------------------------------------------------------------------------
	function toDebugStr($value) {
		if(is_array($value)) {
			return arrayToDebugStr($value);
		}
		else if(is_string($value)) {
			return '"'.$value.'"';
		}
		else {
			return jsonEncodePlus($value);
		}
	}
	//------------------------------------------------------------------------------
	function jsonEncodePlus($value) {//
		$encodedValue = json_encode($value);
		verify(json_last_error() === JSON_ERROR_NONE, "Failed to JSON encode value", cEParseErr);
		return $encodedValue;
	}
	//------------------------------------------------------------------------------
	function arrayToDebugStr($array, $indentPrefix = '') {
		verify(is_array($array), 'Value provided is not an array');
		$resultString = '';
		if(is_null($array)) {
			return 'Array variable is null';
		}
		else if(count($array) === 0) {
			return '[]';
		}
		else {
			foreach($array as $key=> $value) {
				if(is_array($value)) {
					$resultString .= arrayToDebugStr($value, $indentPrefix."[$key]");
				}
				else {
					$resultString .= $indentPrefix."[$key]".toDebugStr($value)."\n";
				}
			}
		}
		return $resultString;
	}
	//------------------------------------------------------------------------------
	function backtraceCallLocation($callsBack = 0) {//
		$functionName = backtraceGet($callsBack + 1, 'function', 'script');
		$lineNumber = backtraceGet($callsBack, 'line', 'unknown line');
		$fileName = backtraceGet($callsBack, 'file', 'unknown file');
		return "line $lineNumber in $fileName by $functionName";
	}
	//------------------------------------------------------------------------------
	function backtraceGet($callsBack, $key, $default = cNoDefault) {//
		$maxIndex = count(debug_backtrace()) - 1;
		if($callsBack > $maxIndex) {
			return $default;
		}
		$backTrace = debug_backtrace();
		$callInfo = arrayGet($backTrace, $callsBack + 1);
		return arrayGet($callInfo, $key, $default);
	}
	//------------------------------------------------------------------------------
	function fileLog($message, $fileName = 'log.txt', $callsBack = 1) {
		errIfNullOrEmptyStr($fileName, 'Filename bad in FileLog');
		$callLocation = backtraceCallLocation($callsBack);
		$fullMessage = isoDateTime()." $message. Logged on $callLocation. \n\n";
		fileAppendText($fullMessage, $fileName);
	}
	//------------------------------------------------------------------------------
	function isoDateTime() {
		return date('Y-m-d H:i:s');
	}
	//------------------------------------------------------------------------------
	function fileAppendText($inputString, $fileName) {
		errIfNullOrEmptyStr($fileName, 'Filename bad in fileAppendText');
		$result = file_put_contents($fileName, $inputString, FILE_APPEND);
		if($result === false) {
			err("File failed to open. Rights are likely needed. ".
					"This can happen if the file was created manualy and not by a PHP script");
		}
	}
	//------------------------------------------------------------------------------
	function errIfNullOrEmptyStr($value, $errMessage = "Value may not be null or an empty string") {//
		errIfNull($value, $errMessage);
		errIf($value === '', $errMessage, cEEmptyStrInvalid);
	}
	//------------------------------------------------------------------------------
	function valRequestMethod($neededMethod) {
		$actualMethod = $_SERVER['REQUEST_METHOD'];
		if($actualMethod !== $neededMethod) {
			errHttp("Invalid Request Method. $neededMethod needed. received $actualMethod", 400);
		}
	}
	//------------------------------------------------------------------------------
	function valRequestMethodPost() {
		valRequestMethod('POST');
	}
	//------------------------------------------------------------------------------
	function valRequestMethodGet() {
		valRequestMethod('GET');
	}
	//------------------------------------------------------------------------------
	function arrayGet($array, $key, $defaultValue = cNoDefault) {//
		valArrayAndKey($array, $key);
		$trueKey = arrayTrueKey($array, $key, $defaultValue === cNoDefault);
		if(!is_null($trueKey)) {
			return $array[$trueKey];
		}
		return $defaultValue;
	}
	//------------------------------------------------------------------------------
	function valArrayAndKey($array, $key) {//
		errIfNull($array, 'Array may not be null');
		verify(is_array($array), 'Non array passed');
		errIfNull($key, 'Key may not be null');
	}
	//------------------------------------------------------------------------------
	function inputGetJsonDecode() {//
		return jsonDecodePlus(inputGet());
	}
	//------------------------------------------------------------------------------
	function jsonDecodePlus($value) {//
		$decodedValue = json_decode($value, true);
		verify(json_last_error() === JSON_ERROR_NONE, "Failed to JSON decode value", cEParseErr);
		return $decodedValue;
	}
	//------------------------------------------------------------------------------
	function inputGet() {//
		if(array_key_exists('pseudoInputStream', $_POST) &&
				!is_null($_POST['pseudoInputStream'])) {
			return $_POST['pseudoInputStream'];
		}
		else {
			return file_get_contents("php://input");
		}
	}
	//------------------------------------------------------------------------------
	function verify($errCondition, $errMessage = "Verify failed", $errToThrow = cException) {//
		if(!is_bool($errCondition)) {
			err('Condition must be of type boolean. Do not send truthy/falsey conditions');
		}
		if($errCondition === false) {
			err($errMessage, $errToThrow);
		}
	}
	//------------------------------------------------------------------------------
	function err($errMessage, $errToThrow = cException) {//
		if(is_null($errToThrow)) {
			err('Err type provided is null', cENullValueInvalid);
		}
		//throw new $errToThrow($errMessage);
	}
	//------------------------------------------------------------------------------
	function errIfNull($value, $errMessage = "Null value not allowed") {//
		errIf(is_null($value), $errMessage, cENullValueInvalid);
	}
	//------------------------------------------------------------------------------
	function errIf($errCondition, $errMessage = "Error condition met", $errToThrow = cException) {//
		if(!is_bool($errCondition)) {
			err('Condition must be of type boolean. Do not send truthy/falsey conditions');
		}
		if($errCondition === true) {
			err($errMessage, $errToThrow);
		}
	}
	//------------------------------------------------------------------------------
	function arrayTrueKey($array, $key, $errIfKeyMissing = true) {//
		verify(is_string($key) or is_numeric($key), 'Key must be a string or integer');

		$origKey = $key;

		if(is_numeric($key)) {
			$key = (integer) $key;
		}

		if(array_key_exists($key, $array)) {
			return $key;
		}

		$key = (string) $key;
		$key = strtoupper($key);
		if(array_key_exists($key, $array)) {
			return $key;
		}

		$key = strtolower($key);
		if(array_key_exists($key, $array)) {
			return $key;
		}

		foreach($array as $trueKey=> $toss) {
			$toss = $toss; //keep unused variable warning from showing 
			if(strtolower($trueKey) === $key) {
				return $trueKey;
			}
		}

		errIf($errIfKeyMissing, "Key $origKey not found in array");
		return null;
	}
	function mimeTypeForExtension($ext) {
		$mime_types = array(
			'ai'      => 'application/postscript',
			'aif'     => 'audio/x-aiff',
			'aifc'    => 'audio/x-aiff',
			'aiff'    => 'audio/x-aiff',
			'asc'     => 'text/plain',
			'asf'     => 'video/x-ms-asf',
			'asx'     => 'video/x-ms-asf',
			'au'      => 'audio/basic',
			'avi'     => 'video/x-msvideo',
			'bcpio'   => 'application/x-bcpio',
			'bin'     => 'application/octet-stream',
			'bmp'     => 'image/bmp',
			'bz2'     => 'application/x-bzip2',
			'cdf'     => 'application/x-netcdf',
			'chrt'    => 'application/x-kchart',
			'class'   => 'application/octet-stream',
			'cpio'    => 'application/x-cpio',
			'cpt'     => 'application/mac-compactpro',
			'csh'     => 'application/x-csh',
			'css'     => 'text/css',
			'dcr'     => 'application/x-director',
			'dir'     => 'application/x-director',
			'djv'     => 'image/vnd.djvu',
			'djvu'    => 'image/vnd.djvu',
			'dll'     => 'application/octet-stream',
			'dms'     => 'application/octet-stream',
			'doc'     => 'application/msword',
			'dvi'     => 'application/x-dvi',
			'dxr'     => 'application/x-director',
			'eps'     => 'application/postscript',
			'etx'     => 'text/x-setext',
			'exe'     => 'application/octet-stream',
			'ez'      => 'application/andrew-inset',
			'flv'     => 'video/x-flv',
			'gif'     => 'image/gif',
			'gtar'    => 'application/x-gtar',
			'gz'      => 'application/x-gzip',
			'hdf'     => 'application/x-hdf',
			'hqx'     => 'application/mac-binhex40',
			'htm'     => 'text/html',
			'html'    => 'text/html',
			'ice'     => 'x-conference/x-cooltalk',
			'ief'     => 'image/ief',
			'iges'    => 'model/iges',
			'igs'     => 'model/iges',
			'img'     => 'application/octet-stream',
			'iso'     => 'application/octet-stream',
			'jad'     => 'text/vnd.sun.j2me.app-descriptor',
			'jar'     => 'application/x-java-archive',
			'jnlp'    => 'application/x-java-jnlp-file',
			'jpe'     => 'image/jpeg',
			'jpeg'    => 'image/jpeg',
			'jpg'     => 'image/jpeg',
			'js'      => 'application/x-javascript',
			'kar'     => 'audio/midi',
			'kil'     => 'application/x-killustrator',
			'kpr'     => 'application/x-kpresenter',
			'kpt'     => 'application/x-kpresenter',
			'ksp'     => 'application/x-kspread',
			'kwd'     => 'application/x-kword',
			'kwt'     => 'application/x-kword',
			'latex'   => 'application/x-latex',
			'lha'     => 'application/octet-stream',
			'lzh'     => 'application/octet-stream',
			'm3u'     => 'audio/x-mpegurl',
			'man'     => 'application/x-troff-man',
			'me'      => 'application/x-troff-me',
			'mesh'    => 'model/mesh',
			'mid'     => 'audio/midi',
			'midi'    => 'audio/midi',
			'mif'     => 'application/vnd.mif',
			'mov'     => 'video/quicktime',
			'movie'   => 'video/x-sgi-movie',
			'mp2'     => 'audio/mpeg',
			'mp3'     => 'audio/mpeg',
			'mpe'     => 'video/mpeg',
			'mpeg'    => 'video/mpeg',
			'mpg'     => 'video/mpeg',
			'mpga'    => 'audio/mpeg',
			'ms'      => 'application/x-troff-ms',
			'msh'     => 'model/mesh',
			'mxu'     => 'video/vnd.mpegurl',
			'nc'      => 'application/x-netcdf',
			'odb'     => 'application/vnd.oasis.opendocument.database',
			'odc'     => 'application/vnd.oasis.opendocument.chart',
			'odf'     => 'application/vnd.oasis.opendocument.formula',
			'odg'     => 'application/vnd.oasis.opendocument.graphics',
			'odi'     => 'application/vnd.oasis.opendocument.image',
			'odm'     => 'application/vnd.oasis.opendocument.text-master',
			'odp'     => 'application/vnd.oasis.opendocument.presentation',
			'ods'     => 'application/vnd.oasis.opendocument.spreadsheet',
			'odt'     => 'application/vnd.oasis.opendocument.text',
			'ogg'     => 'application/ogg',
			'otg'     => 'application/vnd.oasis.opendocument.graphics-template',
			'oth'     => 'application/vnd.oasis.opendocument.text-web',
			'otp'     => 'application/vnd.oasis.opendocument.presentation-template',
			'ots'     => 'application/vnd.oasis.opendocument.spreadsheet-template',
			'ott'     => 'application/vnd.oasis.opendocument.text-template',
			'pbm'     => 'image/x-portable-bitmap',
			'pdb'     => 'chemical/x-pdb',
			'pdf'     => 'application/pdf',
			'pgm'     => 'image/x-portable-graymap',
			'pgn'     => 'application/x-chess-pgn',
			'png'     => 'image/png',
			'pnm'     => 'image/x-portable-anymap',
			'ppm'     => 'image/x-portable-pixmap',
			'ppt'     => 'application/vnd.ms-powerpoint',
			'ps'      => 'application/postscript',
			'qt'      => 'video/quicktime',
			'ra'      => 'audio/x-realaudio',
			'ram'     => 'audio/x-pn-realaudio',
			'ras'     => 'image/x-cmu-raster',
			'rgb'     => 'image/x-rgb',
			'rm'      => 'audio/x-pn-realaudio',
			'roff'    => 'application/x-troff',
			'rpm'     => 'application/x-rpm',
			'rtf'     => 'text/rtf',
			'rtx'     => 'text/richtext',
			'sgm'     => 'text/sgml',
			'sgml'    => 'text/sgml',
			'sh'      => 'application/x-sh',
			'shar'    => 'application/x-shar',
			'silo'    => 'model/mesh',
			'sis'     => 'application/vnd.symbian.install',
			'sit'     => 'application/x-stuffit',
			'skd'     => 'application/x-koan',
			'skm'     => 'application/x-koan',
			'skp'     => 'application/x-koan',
			'skt'     => 'application/x-koan',
			'smi'     => 'application/smil',
			'smil'    => 'application/smil',
			'snd'     => 'audio/basic',
			'so'      => 'application/octet-stream',
			'spl'     => 'application/x-futuresplash',
			'src'     => 'application/x-wais-source',
			'stc'     => 'application/vnd.sun.xml.calc.template',
			'std'     => 'application/vnd.sun.xml.draw.template',
			'sti'     => 'application/vnd.sun.xml.impress.template',
			'stw'     => 'application/vnd.sun.xml.writer.template',
			'sv4cpio' => 'application/x-sv4cpio',
			'sv4crc'  => 'application/x-sv4crc',
			'swf'     => 'application/x-shockwave-flash',
			'sxc'     => 'application/vnd.sun.xml.calc',
			'sxd'     => 'application/vnd.sun.xml.draw',
			'sxg'     => 'application/vnd.sun.xml.writer.global',
			'sxi'     => 'application/vnd.sun.xml.impress',
			'sxm'     => 'application/vnd.sun.xml.math',
			'sxw'     => 'application/vnd.sun.xml.writer',
			't'       => 'application/x-troff',
			'tar'     => 'application/x-tar',
			'tcl'     => 'application/x-tcl',
			'tex'     => 'application/x-tex',
			'texi'    => 'application/x-texinfo',
			'texinfo' => 'application/x-texinfo',
			'tgz'     => 'application/x-gzip',
			'tif'     => 'image/tiff',
			'tiff'    => 'image/tiff',
			'torrent' => 'application/x-bittorrent',
			'tr'      => 'application/x-troff',
			'tsv'     => 'text/tab-separated-values',
			'txt'     => 'text/plain',
			'ustar'   => 'application/x-ustar',
			'vcd'     => 'application/x-cdlink',
			'vrml'    => 'model/vrml',
			'wav'     => 'audio/x-wav',
			'wax'     => 'audio/x-ms-wax',
			'wbmp'    => 'image/vnd.wap.wbmp',
			'wbxml'   => 'application/vnd.wap.wbxml',
			'wm'      => 'video/x-ms-wm',
			'wma'     => 'audio/x-ms-wma',
			'wml'     => 'text/vnd.wap.wml',
			'wmlc'    => 'application/vnd.wap.wmlc',
			'wmls'    => 'text/vnd.wap.wmlscript',
			'wmlsc'   => 'application/vnd.wap.wmlscriptc',
			'wmv'     => 'video/x-ms-wmv',
			'wmx'     => 'video/x-ms-wmx',
			'wrl'     => 'model/vrml',
			'wvx'     => 'video/x-ms-wvx',
			'xbm'     => 'image/x-xbitmap',
			'xht'     => 'application/xhtml+xml',
			'xhtml'   => 'application/xhtml+xml',
			'xls'     => 'application/vnd.ms-excel',
			'xml'     => 'text/xml',
			'xpm'     => 'image/x-xpixmap',
			'xsl'     => 'text/xml',
			'xwd'     => 'image/x-xwindowdump',
			'xyz'     => 'chemical/x-xyz',
			'zip'     => 'application/zip'
		);

		return $mime_types[$ext];
	}
?>